org.fourthline.cling.model.meta

## Class RemoteDevice

- java.lang.Object
- - org.fourthline.cling.model.meta.Device<RemoteDeviceIdentity,RemoteDevice,RemoteService>
  - - org.fourthline.cling.model.meta.RemoteDevice

- All Implemented Interfaces:
    Validatable

      public class RemoteDevice
      extends Device<RemoteDeviceIdentity,RemoteDevice,RemoteService>

  The metadata of a device that was discovered on the network.
  Author:
    Christian Bauer

- - ### Field Summary

    - ### Fields inherited from class org.fourthline.cling.model.meta.Device

      `embeddedDevices, services`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RemoteDevice(RemoteDeviceIdentity identity)`
    `RemoteDevice(RemoteDeviceIdentity identity, DeviceType type, DeviceDetails details, Icon[] icons, RemoteService service)`
    `RemoteDevice(RemoteDeviceIdentity identity, DeviceType type, DeviceDetails details, Icon[] icons, RemoteService[] services)`
    `RemoteDevice(RemoteDeviceIdentity identity, DeviceType type, DeviceDetails details, Icon[] icons, RemoteService[] services, RemoteDevice[] embeddedDevices)`
    `RemoteDevice(RemoteDeviceIdentity identity, DeviceType type, DeviceDetails details, Icon[] icons, RemoteService service, RemoteDevice embeddedDevice)`
    `RemoteDevice(RemoteDeviceIdentity identity, DeviceType type, DeviceDetails details, Icon icon, RemoteService service)`
    `RemoteDevice(RemoteDeviceIdentity identity, DeviceType type, DeviceDetails details, Icon icon, RemoteService[] services)`
    `RemoteDevice(RemoteDeviceIdentity identity, DeviceType type, DeviceDetails details, Icon icon, RemoteService[] services, RemoteDevice[] embeddedDevices)`
    `RemoteDevice(RemoteDeviceIdentity identity, DeviceType type, DeviceDetails details, Icon icon, RemoteService service, RemoteDevice embeddedDevice)`
    `RemoteDevice(RemoteDeviceIdentity identity, DeviceType type, DeviceDetails details, RemoteService service)`
    `RemoteDevice(RemoteDeviceIdentity identity, DeviceType type, DeviceDetails details, RemoteService[] services)`
    `RemoteDevice(RemoteDeviceIdentity identity, DeviceType type, DeviceDetails details, RemoteService[] services, RemoteDevice[] embeddedDevices)`
    `RemoteDevice(RemoteDeviceIdentity identity, DeviceType type, DeviceDetails details, RemoteService service, RemoteDevice embeddedDevice)`
    `RemoteDevice(RemoteDeviceIdentity identity, UDAVersion version, DeviceType type, DeviceDetails details, Icon[] icons, RemoteService[] services, RemoteDevice[] embeddedDevices)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Resource[]` | `discoverResources(Namespace namespace)`
    `RemoteDevice` | `findDevice(UDN udn)`
    `RemoteDevice[]` | `getEmbeddedDevices()`
    `RemoteDevice` | `getRoot()`
    `RemoteService[]` | `getServices()`
    `RemoteService` | `newInstance(ServiceType serviceType, ServiceId serviceId, URI descriptorURI, URI controlURI, URI eventSubscriptionURI, Action<RemoteService>[] actions, StateVariable<RemoteService>[] stateVariables)`
    `RemoteDevice` | `newInstance(UDN udn, UDAVersion version, DeviceType type, DeviceDetails details, Icon[] icons, RemoteService[] services, List<RemoteDevice> embeddedDevices)`
    `RemoteService[]` | `newServiceArray(int size)`
    `URL` | `normalizeURI(URI relativeOrAbsoluteURI)`
    `RemoteDevice[]` | `toDeviceArray(Collection<RemoteDevice> col)`
    `RemoteService[]` | `toServiceArray(Collection<RemoteService> col)`

    - ### Methods inherited from class org.fourthline.cling.model.meta.Device

      `equals, find, find, find, findDevices, findDevices, findEmbeddedDevices, findEmbeddedDevices, findIcons, findService, findService, findServices, findServices, findServices, findServiceTypes, getDetails, getDetails, getDisplayString, getIcons, getIdentity, getParentDevice, getType, getVersion, hasEmbeddedDevices, hashCode, hasIcons, hasServices, isFullyHydrated, isRoot, toString, validate`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### RemoteDevice

          public RemoteDevice(RemoteDeviceIdentity identity)
                       throws ValidationException

      Throws:
        `ValidationException`

    - #### RemoteDevice

          public RemoteDevice(RemoteDeviceIdentity identity,
                              DeviceType type,
                              DeviceDetails details,
                              RemoteService service)
                       throws ValidationException

      Throws:
        `ValidationException`

    - #### RemoteDevice

          public RemoteDevice(RemoteDeviceIdentity identity,
                              DeviceType type,
                              DeviceDetails details,
                              RemoteService service,
                              RemoteDevice embeddedDevice)
                       throws ValidationException

      Throws:
        `ValidationException`

    - #### RemoteDevice

          public RemoteDevice(RemoteDeviceIdentity identity,
                              DeviceType type,
                              DeviceDetails details,
                              RemoteService[] services)
                       throws ValidationException

      Throws:
        `ValidationException`

    - #### RemoteDevice

          public RemoteDevice(RemoteDeviceIdentity identity,
                              DeviceType type,
                              DeviceDetails details,
                              RemoteService[] services,
                              RemoteDevice[] embeddedDevices)
                       throws ValidationException

      Throws:
        `ValidationException`

    - #### RemoteDevice

          public RemoteDevice(RemoteDeviceIdentity identity,
                              DeviceType type,
                              DeviceDetails details,
                              Icon icon,
                              RemoteService service)
                       throws ValidationException

      Throws:
        `ValidationException`

    - #### RemoteDevice

          public RemoteDevice(RemoteDeviceIdentity identity,
                              DeviceType type,
                              DeviceDetails details,
                              Icon icon,
                              RemoteService service,
                              RemoteDevice embeddedDevice)
                       throws ValidationException

      Throws:
        `ValidationException`

    - #### RemoteDevice

          public RemoteDevice(RemoteDeviceIdentity identity,
                              DeviceType type,
                              DeviceDetails details,
                              Icon icon,
                              RemoteService[] services)
                       throws ValidationException

      Throws:
        `ValidationException`

    - #### RemoteDevice

          public RemoteDevice(RemoteDeviceIdentity identity,
                              DeviceType type,
                              DeviceDetails details,
                              Icon icon,
                              RemoteService[] services,
                              RemoteDevice[] embeddedDevices)
                       throws ValidationException

      Throws:
        `ValidationException`

    - #### RemoteDevice

          public RemoteDevice(RemoteDeviceIdentity identity,
                              DeviceType type,
                              DeviceDetails details,
                              Icon[] icons,
                              RemoteService service)
                       throws ValidationException

      Throws:
        `ValidationException`

    - #### RemoteDevice

          public RemoteDevice(RemoteDeviceIdentity identity,
                              DeviceType type,
                              DeviceDetails details,
                              Icon[] icons,
                              RemoteService service,
                              RemoteDevice embeddedDevice)
                       throws ValidationException

      Throws:
        `ValidationException`

    - #### RemoteDevice

          public RemoteDevice(RemoteDeviceIdentity identity,
                              DeviceType type,
                              DeviceDetails details,
                              Icon[] icons,
                              RemoteService[] services)
                       throws ValidationException

      Throws:
        `ValidationException`

    - #### RemoteDevice

          public RemoteDevice(RemoteDeviceIdentity identity,
                              DeviceType type,
                              DeviceDetails details,
                              Icon[] icons,
                              RemoteService[] services,
                              RemoteDevice[] embeddedDevices)
                       throws ValidationException

      Throws:
        `ValidationException`

    - #### RemoteDevice

          public RemoteDevice(RemoteDeviceIdentity identity,
                              UDAVersion version,
                              DeviceType type,
                              DeviceDetails details,
                              Icon[] icons,
                              RemoteService[] services,
                              RemoteDevice[] embeddedDevices)
                       throws ValidationException

      Throws:
        `ValidationException`

  - ### Method Detail

    - #### getServices

          public RemoteService[] getServices()

      Specified by:
        `getServices` in class `Device<RemoteDeviceIdentity,RemoteDevice,RemoteService>`

    - #### getEmbeddedDevices

          public RemoteDevice[] getEmbeddedDevices()

      Specified by:
        `getEmbeddedDevices` in class `Device<RemoteDeviceIdentity,RemoteDevice,RemoteService>`

    - #### normalizeURI

          public URL normalizeURI(URI relativeOrAbsoluteURI)

    - #### newInstance

          public RemoteDevice newInstance(UDN udn,
                                          UDAVersion version,
                                          DeviceType type,
                                          DeviceDetails details,
                                          Icon[] icons,
                                          RemoteService[] services,
                                          List<RemoteDevice> embeddedDevices)
                                   throws ValidationException

      Specified by:
        `newInstance` in class `Device<RemoteDeviceIdentity,RemoteDevice,RemoteService>`
      Throws:
        `ValidationException`

    - #### newInstance

          public RemoteService newInstance(ServiceType serviceType,
                                           ServiceId serviceId,
                                           URI descriptorURI,
                                           URI controlURI,
                                           URI eventSubscriptionURI,
                                           Action<RemoteService>[] actions,
                                           StateVariable<RemoteService>[] stateVariables)
                                    throws ValidationException

      Specified by:
        `newInstance` in class `Device<RemoteDeviceIdentity,RemoteDevice,RemoteService>`
      Throws:
        `ValidationException`

    - #### toDeviceArray

          public RemoteDevice[] toDeviceArray(Collection<RemoteDevice> col)

      Specified by:
        `toDeviceArray` in class `Device<RemoteDeviceIdentity,RemoteDevice,RemoteService>`

    - #### newServiceArray

          public RemoteService[] newServiceArray(int size)

      Specified by:
        `newServiceArray` in class `Device<RemoteDeviceIdentity,RemoteDevice,RemoteService>`

    - #### toServiceArray

          public RemoteService[] toServiceArray(Collection<RemoteService> col)

      Specified by:
        `toServiceArray` in class `Device<RemoteDeviceIdentity,RemoteDevice,RemoteService>`

    - #### discoverResources

          public Resource[] discoverResources(Namespace namespace)

      Specified by:
        `discoverResources` in class `Device<RemoteDeviceIdentity,RemoteDevice,RemoteService>`

    - #### getRoot

          public RemoteDevice getRoot()

      Specified by:
        `getRoot` in class `Device<RemoteDeviceIdentity,RemoteDevice,RemoteService>`

    - #### findDevice

          public RemoteDevice findDevice(UDN udn)

      Specified by:
        `findDevice` in class `Device<RemoteDeviceIdentity,RemoteDevice,RemoteService>`

Copyright © 2016 4th Line GmbH, Switzerland. All rights reserved.